import{S as Hn,i as Rn,s as Jn,e as o,k as f,w as $,t as s,M as Qn,c as a,d as n,m as d,a as i,x as P,h as r,b as p,G as e,g as y,y as D,q as x,o as S,B as k,v as Xn,L as Bn}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as K}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as Kn}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as zn}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Wn}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Yn(de){let u,C,_,m,I;return m=new Kn({props:{code:`import requests
import torch
from PIL import Image
from io import BytesIO

from diffusers import StableDiffusionImg2ImgPipeline

device = "cuda"
model_id_or_path = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionImg2ImgPipeline.from_pretrained(model_id_or_path, torch_dtype=torch.float16)
pipe = pipe.to(device)

url = "https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg"

response = requests.get(url)
init_image = Image.open(BytesIO(response.content)).convert("RGB")
init_image = init_image.resize((768, 512))

prompt = "A fantasy landscape, trending on artstation"

images = pipe(prompt=prompt, image=init_image, strength=0.75, guidance_scale=7.5).images
images[0].save("fantasy_landscape.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionImg2ImgPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_id_or_path = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionImg2ImgPipeline.from_pretrained(model_id_or_path, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(device)

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = init_image.resize((<span class="hljs-number">768</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;A fantasy landscape, trending on artstation&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipe(prompt=prompt, image=init_image, strength=<span class="hljs-number">0.75</span>, guidance_scale=<span class="hljs-number">7.5</span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;fantasy_landscape.png&quot;</span>)`}}),{c(){u=o("p"),C=s("Examples:"),_=f(),$(m.$$.fragment)},l(l){u=a(l,"P",{});var b=i(u);C=r(b,"Examples:"),b.forEach(n),_=d(l),P(m.$$.fragment,l)},m(l,b){y(l,u,b),e(u,C),y(l,_,b),D(m,l,b),I=!0},p:Bn,i(l){I||(x(m.$$.fragment,l),I=!0)},o(l){S(m.$$.fragment,l),I=!1},d(l){l&&n(u),l&&n(_),k(m,l)}}}function Zn(de){let u,C,_,m,I;return m=new Kn({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){u=o("p"),C=s("Examples:"),_=f(),$(m.$$.fragment)},l(l){u=a(l,"P",{});var b=i(u);C=r(b,"Examples:"),b.forEach(n),_=d(l),P(m.$$.fragment,l)},m(l,b){y(l,u,b),e(u,C),y(l,_,b),D(m,l,b),I=!0},p:Bn,i(l){I||(x(m.$$.fragment,l),I=!0)},o(l){S(m.$$.fragment,l),I=!1},d(l){l&&n(u),l&&n(_),k(m,l)}}}function eo(de){let u,C,_,m,I,l,b,ve,Ye,Ne,O,N,ye,H,Ze,Ie,et,Ue,v,tt,R,nt,ot,J,at,it,Q,st,rt,X,lt,pt,ce,ft,dt,Fe,Y,ct,Z,mt,Ge,U,me,ut,gt,ue,ht,Ve,c,ee,_t,we,bt,vt,te,yt,ge,It,wt,$t,T,ne,Pt,$e,Dt,xt,F,St,A,oe,kt,Pe,Et,Ct,De,jt,Tt,G,ae,At,ie,qt,xe,Lt,Ot,Mt,w,se,Nt,Se,Ut,Ft,ke,Gt,Vt,Ee,zt,Wt,V,Bt,z,re,Kt,Ce,Ht,Rt,W,le,Jt,E,Qt,je,Xt,Yt,Te,Zt,en,Ae,tn,nn,qe,on,an,sn,B,pe,rn,M,ln,Le,pn,fn,Oe,dn,cn,ze;return l=new zn({}),H=new zn({}),ee=new K({props:{name:"class diffusers.StableDiffusionImg2ImgPipeline",anchor:"diffusers.StableDiffusionImg2ImgPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/v0.13.0/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/v0.13.0/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/v0.13.0/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/v0.13.0/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/v0.13.0/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/v0.13.0/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/v0.13.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L93"}}),ne=new K({props:{name:"__call__",anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"strength",val:": float = 0.8"},{name:"num_inference_steps",val:": typing.Optional[int] = 50"},{name:"guidance_scale",val:": typing.Optional[float] = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": typing.Optional[float] = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, that will be used as the starting point for the
process.`,name:"image"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in
<code>num_inference_steps</code>. A value of 1, therefore, essentially ignores <code>image</code>.`,name:"strength"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference. This parameter will be modulated by <code>strength</code>.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code>
is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/v0.13.0/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/v0.13.0/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/v0.13.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L556",returnDescription:`
<p><a
  href="/docs/diffusers/v0.13.0/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/v0.13.0/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),F=new Wn({props:{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.example",$$slots:{default:[Yn]},$$scope:{ctx:de}}}),oe=new K({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maxium amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/v0.13.0/src/diffusers/pipelines/pipeline_utils.py#L1028"}}),ae=new K({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionImg2ImgPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/v0.13.0/src/diffusers/pipelines/pipeline_utils.py#L1044"}}),se=new K({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/v0.13.0/src/diffusers/pipelines/pipeline_utils.py#L971"}}),V=new Wn({props:{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Zn]},$$scope:{ctx:de}}}),re=new K({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionImg2ImgPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/v0.13.0/src/diffusers/pipelines/pipeline_utils.py#L1003"}}),le=new K({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/v0.13.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L235"}}),pe=new K({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/v0.13.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L213"}}),{c(){u=o("meta"),C=f(),_=o("h1"),m=o("a"),I=o("span"),$(l.$$.fragment),b=f(),ve=o("span"),Ye=s("Image-to-Image Generation"),Ne=f(),O=o("h2"),N=o("a"),ye=o("span"),$(H.$$.fragment),Ze=f(),Ie=o("span"),et=s("StableDiffusionImg2ImgPipeline"),Ue=f(),v=o("p"),tt=s("The Stable Diffusion model was created by the researchers and engineers from "),R=o("a"),nt=s("CompVis"),ot=s(", "),J=o("a"),at=s("Stability AI"),it=s(", "),Q=o("a"),st=s("runway"),rt=s(", and "),X=o("a"),lt=s("LAION"),pt=s(". The "),ce=o("a"),ft=s("StableDiffusionImg2ImgPipeline"),dt=s(" lets you pass a text prompt and an initial image to condition the generation of new images using Stable Diffusion."),Fe=f(),Y=o("p"),ct=s("The original codebase can be found here: "),Z=o("a"),mt=s("CampVis/stable-diffusion"),Ge=f(),U=o("p"),me=o("a"),ut=s("StableDiffusionImg2ImgPipeline"),gt=s(" is compatible with all Stable Diffusion checkpoints for "),ue=o("a"),ht=s("Text-to-Image"),Ve=f(),c=o("div"),$(ee.$$.fragment),_t=f(),we=o("p"),bt=s("Pipeline for text-guided image to image generation using Stable Diffusion."),vt=f(),te=o("p"),yt=s("This model inherits from "),ge=o("a"),It=s("DiffusionPipeline"),wt=s(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),$t=f(),T=o("div"),$(ne.$$.fragment),Pt=f(),$e=o("p"),Dt=s("Function invoked when calling the pipeline for generation."),xt=f(),$(F.$$.fragment),St=f(),A=o("div"),$(oe.$$.fragment),kt=f(),Pe=o("p"),Et=s("Enable sliced attention computation."),Ct=f(),De=o("p"),jt=s(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Tt=f(),G=o("div"),$(ae.$$.fragment),At=f(),ie=o("p"),qt=s("Disable sliced attention computation. If "),xe=o("code"),Lt=s("enable_attention_slicing"),Ot=s(` was previously invoked, this method will go
back to computing attention in one step.`),Mt=f(),w=o("div"),$(se.$$.fragment),Nt=f(),Se=o("p"),Ut=s("Enable memory efficient attention as implemented in xformers."),Ft=f(),ke=o("p"),Gt=s(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Vt=f(),Ee=o("p"),zt=s(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Wt=f(),$(V.$$.fragment),Bt=f(),z=o("div"),$(re.$$.fragment),Kt=f(),Ce=o("p"),Ht=s("Disable memory efficient attention as implemented in xformers."),Rt=f(),W=o("div"),$(le.$$.fragment),Jt=f(),E=o("p"),Qt=s(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),je=o("code"),Xt=s("enable_sequential_cpu_offload"),Yt=s(", this method moves one whole model at a time to the GPU when its "),Te=o("code"),Zt=s("forward"),en=s(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ae=o("code"),tn=s("enable_sequential_cpu_offload"),nn=s(", but performance is much better due to the iterative execution of the "),qe=o("code"),on=s("unet"),an=s("."),sn=f(),B=o("div"),$(pe.$$.fragment),rn=f(),M=o("p"),ln=s(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Le=o("code"),pn=s("torch.device('meta') and loaded to GPU only when their specific submodule has its "),fn=s("forward"),Oe=o("code"),dn=s("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),cn=s("enable_model_cpu_offload`, but performance is lower."),this.h()},l(t){const g=Qn('[data-svelte="svelte-1phssyn"]',document.head);u=a(g,"META",{name:!0,content:!0}),g.forEach(n),C=d(t),_=a(t,"H1",{class:!0});var fe=i(_);m=a(fe,"A",{id:!0,class:!0,href:!0});var Me=i(m);I=a(Me,"SPAN",{});var un=i(I);P(l.$$.fragment,un),un.forEach(n),Me.forEach(n),b=d(fe),ve=a(fe,"SPAN",{});var gn=i(ve);Ye=r(gn,"Image-to-Image Generation"),gn.forEach(n),fe.forEach(n),Ne=d(t),O=a(t,"H2",{class:!0});var We=i(O);N=a(We,"A",{id:!0,class:!0,href:!0});var hn=i(N);ye=a(hn,"SPAN",{});var _n=i(ye);P(H.$$.fragment,_n),_n.forEach(n),hn.forEach(n),Ze=d(We),Ie=a(We,"SPAN",{});var bn=i(Ie);et=r(bn,"StableDiffusionImg2ImgPipeline"),bn.forEach(n),We.forEach(n),Ue=d(t),v=a(t,"P",{});var j=i(v);tt=r(j,"The Stable Diffusion model was created by the researchers and engineers from "),R=a(j,"A",{href:!0,rel:!0});var vn=i(R);nt=r(vn,"CompVis"),vn.forEach(n),ot=r(j,", "),J=a(j,"A",{href:!0,rel:!0});var yn=i(J);at=r(yn,"Stability AI"),yn.forEach(n),it=r(j,", "),Q=a(j,"A",{href:!0,rel:!0});var In=i(Q);st=r(In,"runway"),In.forEach(n),rt=r(j,", and "),X=a(j,"A",{href:!0,rel:!0});var wn=i(X);lt=r(wn,"LAION"),wn.forEach(n),pt=r(j,". The "),ce=a(j,"A",{href:!0});var $n=i(ce);ft=r($n,"StableDiffusionImg2ImgPipeline"),$n.forEach(n),dt=r(j," lets you pass a text prompt and an initial image to condition the generation of new images using Stable Diffusion."),j.forEach(n),Fe=d(t),Y=a(t,"P",{});var mn=i(Y);ct=r(mn,"The original codebase can be found here: "),Z=a(mn,"A",{href:!0,rel:!0});var Pn=i(Z);mt=r(Pn,"CampVis/stable-diffusion"),Pn.forEach(n),mn.forEach(n),Ge=d(t),U=a(t,"P",{});var Be=i(U);me=a(Be,"A",{href:!0});var Dn=i(me);ut=r(Dn,"StableDiffusionImg2ImgPipeline"),Dn.forEach(n),gt=r(Be," is compatible with all Stable Diffusion checkpoints for "),ue=a(Be,"A",{href:!0});var xn=i(ue);ht=r(xn,"Text-to-Image"),xn.forEach(n),Be.forEach(n),Ve=d(t),c=a(t,"DIV",{class:!0});var h=i(c);P(ee.$$.fragment,h),_t=d(h),we=a(h,"P",{});var Sn=i(we);bt=r(Sn,"Pipeline for text-guided image to image generation using Stable Diffusion."),Sn.forEach(n),vt=d(h),te=a(h,"P",{});var Ke=i(te);yt=r(Ke,"This model inherits from "),ge=a(Ke,"A",{href:!0});var kn=i(ge);It=r(kn,"DiffusionPipeline"),kn.forEach(n),wt=r(Ke,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Ke.forEach(n),$t=d(h),T=a(h,"DIV",{class:!0});var he=i(T);P(ne.$$.fragment,he),Pt=d(he),$e=a(he,"P",{});var En=i($e);Dt=r(En,"Function invoked when calling the pipeline for generation."),En.forEach(n),xt=d(he),P(F.$$.fragment,he),he.forEach(n),St=d(h),A=a(h,"DIV",{class:!0});var _e=i(A);P(oe.$$.fragment,_e),kt=d(_e),Pe=a(_e,"P",{});var Cn=i(Pe);Et=r(Cn,"Enable sliced attention computation."),Cn.forEach(n),Ct=d(_e),De=a(_e,"P",{});var jn=i(De);jt=r(jn,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),jn.forEach(n),_e.forEach(n),Tt=d(h),G=a(h,"DIV",{class:!0});var He=i(G);P(ae.$$.fragment,He),At=d(He),ie=a(He,"P",{});var Re=i(ie);qt=r(Re,"Disable sliced attention computation. If "),xe=a(Re,"CODE",{});var Tn=i(xe);Lt=r(Tn,"enable_attention_slicing"),Tn.forEach(n),Ot=r(Re,` was previously invoked, this method will go
back to computing attention in one step.`),Re.forEach(n),He.forEach(n),Mt=d(h),w=a(h,"DIV",{class:!0});var q=i(w);P(se.$$.fragment,q),Nt=d(q),Se=a(q,"P",{});var An=i(Se);Ut=r(An,"Enable memory efficient attention as implemented in xformers."),An.forEach(n),Ft=d(q),ke=a(q,"P",{});var qn=i(ke);Gt=r(qn,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),qn.forEach(n),Vt=d(q),Ee=a(q,"P",{});var Ln=i(Ee);zt=r(Ln,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Ln.forEach(n),Wt=d(q),P(V.$$.fragment,q),q.forEach(n),Bt=d(h),z=a(h,"DIV",{class:!0});var Je=i(z);P(re.$$.fragment,Je),Kt=d(Je),Ce=a(Je,"P",{});var On=i(Ce);Ht=r(On,"Disable memory efficient attention as implemented in xformers."),On.forEach(n),Je.forEach(n),Rt=d(h),W=a(h,"DIV",{class:!0});var Qe=i(W);P(le.$$.fragment,Qe),Jt=d(Qe),E=a(Qe,"P",{});var L=i(E);Qt=r(L,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),je=a(L,"CODE",{});var Mn=i(je);Xt=r(Mn,"enable_sequential_cpu_offload"),Mn.forEach(n),Yt=r(L,", this method moves one whole model at a time to the GPU when its "),Te=a(L,"CODE",{});var Nn=i(Te);Zt=r(Nn,"forward"),Nn.forEach(n),en=r(L,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ae=a(L,"CODE",{});var Un=i(Ae);tn=r(Un,"enable_sequential_cpu_offload"),Un.forEach(n),nn=r(L,", but performance is much better due to the iterative execution of the "),qe=a(L,"CODE",{});var Fn=i(qe);on=r(Fn,"unet"),Fn.forEach(n),an=r(L,"."),L.forEach(n),Qe.forEach(n),sn=d(h),B=a(h,"DIV",{class:!0});var Xe=i(B);P(pe.$$.fragment,Xe),rn=d(Xe),M=a(Xe,"P",{});var be=i(M);ln=r(be,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Le=a(be,"CODE",{});var Gn=i(Le);pn=r(Gn,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Gn.forEach(n),fn=r(be,"forward"),Oe=a(be,"CODE",{});var Vn=i(Oe);dn=r(Vn,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Vn.forEach(n),cn=r(be,"enable_model_cpu_offload`, but performance is lower."),be.forEach(n),Xe.forEach(n),h.forEach(n),this.h()},h(){p(u,"name","hf:doc:metadata"),p(u,"content",JSON.stringify(to)),p(m,"id","imagetoimage-generation"),p(m,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(m,"href","#imagetoimage-generation"),p(_,"class","relative group"),p(N,"id","diffusers.StableDiffusionImg2ImgPipeline"),p(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(N,"href","#diffusers.StableDiffusionImg2ImgPipeline"),p(O,"class","relative group"),p(R,"href","https://github.com/CompVis"),p(R,"rel","nofollow"),p(J,"href","https://stability.ai/"),p(J,"rel","nofollow"),p(Q,"href","https://github.com/runwayml"),p(Q,"rel","nofollow"),p(X,"href","https://laion.ai/"),p(X,"rel","nofollow"),p(ce,"href","/docs/diffusers/v0.13.0/en/api/pipelines/stable_diffusion/img2img#diffusers.StableDiffusionImg2ImgPipeline"),p(Z,"href","https://github.com/CompVis/stable-diffusion/blob/main/scripts/img2img.py"),p(Z,"rel","nofollow"),p(me,"href","/docs/diffusers/v0.13.0/en/api/pipelines/stable_diffusion/img2img#diffusers.StableDiffusionImg2ImgPipeline"),p(ue,"href","./text2img"),p(ge,"href","/docs/diffusers/v0.13.0/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),p(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,g){e(document.head,u),y(t,C,g),y(t,_,g),e(_,m),e(m,I),D(l,I,null),e(_,b),e(_,ve),e(ve,Ye),y(t,Ne,g),y(t,O,g),e(O,N),e(N,ye),D(H,ye,null),e(O,Ze),e(O,Ie),e(Ie,et),y(t,Ue,g),y(t,v,g),e(v,tt),e(v,R),e(R,nt),e(v,ot),e(v,J),e(J,at),e(v,it),e(v,Q),e(Q,st),e(v,rt),e(v,X),e(X,lt),e(v,pt),e(v,ce),e(ce,ft),e(v,dt),y(t,Fe,g),y(t,Y,g),e(Y,ct),e(Y,Z),e(Z,mt),y(t,Ge,g),y(t,U,g),e(U,me),e(me,ut),e(U,gt),e(U,ue),e(ue,ht),y(t,Ve,g),y(t,c,g),D(ee,c,null),e(c,_t),e(c,we),e(we,bt),e(c,vt),e(c,te),e(te,yt),e(te,ge),e(ge,It),e(te,wt),e(c,$t),e(c,T),D(ne,T,null),e(T,Pt),e(T,$e),e($e,Dt),e(T,xt),D(F,T,null),e(c,St),e(c,A),D(oe,A,null),e(A,kt),e(A,Pe),e(Pe,Et),e(A,Ct),e(A,De),e(De,jt),e(c,Tt),e(c,G),D(ae,G,null),e(G,At),e(G,ie),e(ie,qt),e(ie,xe),e(xe,Lt),e(ie,Ot),e(c,Mt),e(c,w),D(se,w,null),e(w,Nt),e(w,Se),e(Se,Ut),e(w,Ft),e(w,ke),e(ke,Gt),e(w,Vt),e(w,Ee),e(Ee,zt),e(w,Wt),D(V,w,null),e(c,Bt),e(c,z),D(re,z,null),e(z,Kt),e(z,Ce),e(Ce,Ht),e(c,Rt),e(c,W),D(le,W,null),e(W,Jt),e(W,E),e(E,Qt),e(E,je),e(je,Xt),e(E,Yt),e(E,Te),e(Te,Zt),e(E,en),e(E,Ae),e(Ae,tn),e(E,nn),e(E,qe),e(qe,on),e(E,an),e(c,sn),e(c,B),D(pe,B,null),e(B,rn),e(B,M),e(M,ln),e(M,Le),e(Le,pn),e(M,fn),e(M,Oe),e(Oe,dn),e(M,cn),ze=!0},p(t,[g]){const fe={};g&2&&(fe.$$scope={dirty:g,ctx:t}),F.$set(fe);const Me={};g&2&&(Me.$$scope={dirty:g,ctx:t}),V.$set(Me)},i(t){ze||(x(l.$$.fragment,t),x(H.$$.fragment,t),x(ee.$$.fragment,t),x(ne.$$.fragment,t),x(F.$$.fragment,t),x(oe.$$.fragment,t),x(ae.$$.fragment,t),x(se.$$.fragment,t),x(V.$$.fragment,t),x(re.$$.fragment,t),x(le.$$.fragment,t),x(pe.$$.fragment,t),ze=!0)},o(t){S(l.$$.fragment,t),S(H.$$.fragment,t),S(ee.$$.fragment,t),S(ne.$$.fragment,t),S(F.$$.fragment,t),S(oe.$$.fragment,t),S(ae.$$.fragment,t),S(se.$$.fragment,t),S(V.$$.fragment,t),S(re.$$.fragment,t),S(le.$$.fragment,t),S(pe.$$.fragment,t),ze=!1},d(t){n(u),t&&n(C),t&&n(_),k(l),t&&n(Ne),t&&n(O),k(H),t&&n(Ue),t&&n(v),t&&n(Fe),t&&n(Y),t&&n(Ge),t&&n(U),t&&n(Ve),t&&n(c),k(ee),k(ne),k(F),k(oe),k(ae),k(se),k(V),k(re),k(le),k(pe)}}}const to={local:"imagetoimage-generation",sections:[{local:"diffusers.StableDiffusionImg2ImgPipeline",title:"StableDiffusionImg2ImgPipeline"}],title:"Image-to-Image Generation"};function no(de){return Xn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class lo extends Hn{constructor(u){super();Rn(this,u,no,eo,Jn,{})}}export{lo as default,to as metadata};
